/**************************************************************************************
Interface for array lists. This is what an array list should be able to do.
/**************************************************************************************/
template<typename T>interface IAList
  {
   /**accessing**/
   T                 Get(int);
   T                 First();
   T                 Last();
   T                 operator[](int);
   /**adding**/
   bool              Append(T);
   bool              Prepend(T);
   bool              Insert(T,int);
   bool              operator+=(T);
   /**removing**/
   bool              Remove(T);
   bool              RemoveAt(int);
   bool              RemoveLast();
   bool              RemoveFirst();
   bool              RemoveAll();
   bool              operator-=(T);
   bool              operator~();
   /**general**/
   int               Count();
   int               Find(T);
   string            Print();
   /**stack interface**/
   bool              Push(T);
   T                 Top();
   T                 Pop();
   /**queue interface**/
   bool              Enqueue(T);
   T                 Peek();
   T                 Dequeue();
  };
/**/
